# Generated by Django 5.0.6 on 2024-06-07 14:53

import django.db.models.deletion

from django.conf import settings
from django.db import migrations, models


class Migration(migrations.Migration):
    initial = True

    dependencies = [
        ("wagtail_localize", "0016_rename_page_revision_translationlog_revision"),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name="Project",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("first_synced_at", models.DateTimeField(editable=False, null=True)),
                ("last_synced_at", models.DateTimeField(editable=False, null=True)),
                ("environment", models.CharField(max_length=16)),
                ("account_uid", models.CharField(max_length=32)),
                ("archived", models.BooleanField()),
                ("project_id", models.CharField(max_length=16)),
                ("name", models.CharField(max_length=255)),
                ("type_code", models.CharField(max_length=32)),
                ("source_locale_description", models.CharField(max_length=255)),
                ("source_locale_id", models.CharField(max_length=16)),
            ],
            options={
                "ordering": (
                    models.OrderBy(
                        models.F("first_synced_at"), descending=True, nulls_first=True
                    ),
                    "-pk",
                ),
                "abstract": False,
            },
        ),
        migrations.CreateModel(
            name="ProjectTargetLocale",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("locale_id", models.CharField(max_length=16)),
                ("description", models.CharField(max_length=255)),
                ("enabled", models.BooleanField()),
            ],
        ),
        migrations.CreateModel(
            name="Job",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("first_synced_at", models.DateTimeField(editable=False, null=True)),
                ("last_synced_at", models.DateTimeField(editable=False, null=True)),
                ("name", models.CharField(editable=False, max_length=170)),
                ("description", models.TextField(blank=True, editable=False)),
                ("reference_number", models.CharField(editable=False, max_length=170)),
                ("due_date", models.DateTimeField(blank=True, null=True)),
                (
                    "translation_job_uid",
                    models.CharField(editable=False, max_length=64),
                ),
                (
                    "status",
                    models.CharField(
                        choices=[
                            ("UNSYNCED", "Unsynced"),
                            ("DRAFT", "Draft"),
                            ("AWAITING_AUTHORIZATION", "Awaiting authorization"),
                            ("IN_PROGRESS", "In progress"),
                            ("COMPLETED", "Completed"),
                            ("CANCELLED", "Cancelled"),
                            ("CLOSED", "Closed"),
                            ("DELETED", "Deleted"),
                        ],
                        default="UNSYNCED",
                        editable=False,
                        max_length=32,
                    ),
                ),
                (
                    "translations_imported_at",
                    models.DateTimeField(editable=False, null=True),
                ),
                (
                    "file_uri",
                    models.CharField(blank=True, editable=False, max_length=255),
                ),
                (
                    "translation_source",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="smartling_jobs",
                        to="wagtail_localize.translationsource",
                    ),
                ),
                (
                    "translations",
                    models.ManyToManyField(
                        related_name="smartling_jobs", to="wagtail_localize.translation"
                    ),
                ),
                (
                    "user",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        related_name="+",
                        to=settings.AUTH_USER_MODEL,
                    ),
                ),
            ],
            options={
                "ordering": (
                    models.OrderBy(
                        models.F("first_synced_at"), descending=True, nulls_first=True
                    ),
                    "-pk",
                ),
                "abstract": False,
                "default_permissions": ("view",),
            },
        ),
        migrations.AddConstraint(
            model_name="project",
            constraint=models.CheckConstraint(
                check=models.Q(
                    ("environment", "production"),
                    ("environment", "staging"),
                    _connector="OR",
                ),
                name="project_environment",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="project",
            unique_together={("environment", "account_uid", "project_id")},
        ),
        migrations.AddField(
            model_name="job",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="jobs",
                to="wagtail_localize_smartling.project",
            ),
        ),
        migrations.AddField(
            model_name="projecttargetlocale",
            name="project",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="target_locales",
                to="wagtail_localize_smartling.project",
            ),
        ),
        migrations.AddConstraint(
            model_name="job",
            constraint=models.CheckConstraint(
                check=models.Q(
                    models.Q(
                        ("first_synced_at__isnull", True),
                        ("last_synced_at__isnull", True),
                        ("status", "UNSYNCED"),
                        ("translation_job_uid", ""),
                    ),
                    models.Q(
                        models.Q(("status", "UNSYNCED"), _negated=True),
                        ("first_synced_at__isnull", False),
                        ("last_synced_at__isnull", False),
                        models.Q(("translation_job_uid", ""), _negated=True),
                    ),
                    _connector="OR",
                ),
                name="status_consistent_with_sync_dates",
            ),
        ),
        migrations.AlterUniqueTogether(
            name="projecttargetlocale",
            unique_together={("project", "locale_id")},
        ),
    ]
